package jp.co.asterisk.asreader.a23d.demoapp.fragments;

import android.os.Bundle;
import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.navigation.fragment.NavHostFragment;
import android.text.method.ScrollingMovementMethod;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import jp.co.asterisk.asreader.a23d.demoapp.R;
import jp.co.asterisk.asreader.a23d.demoapp.databinding.FragmentBarcodeAccessBinding;

public class BarcodeAccessFragment extends BaseFragment {

    private FragmentBarcodeAccessBinding binding;

    @Override
    public View onCreateView( @NonNull LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState ) {
        // Inflate the layout for this fragment
        binding = FragmentBarcodeAccessBinding.inflate(inflater, container, false);
        return binding.getRoot();
    }

    @Override
    public void onViewCreated(@NonNull View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);

        setTitle(getString(R.string.barcode));
        setBackButtonVisibility(View.VISIBLE);
        setRightButtonVisibility(View.INVISIBLE);

        binding.barcodeAccessTextView.setMovementMethod(new ScrollingMovementMethod());

        assert getArguments() != null;
        final String selectedTag = getArguments().getString("selectTag");
        binding.barcodeAccessTextView.setText(selectedTag);
    }

    @Override
    public void onStart() {
        super.onStart();
        Log.d("BarcodeAccessFragment", "onStart");
        enableActionBar(true);
    }

    @Override
    public void onConnect(boolean isConnect) {
        Log.d("BarcodeAccessFragment", "onConnect: " + isConnect);
        if( !isConnect ) {
            NavHostFragment.findNavController(BarcodeAccessFragment.this)
                    .navigate(R.id.action_BarcodeAccessFragment_to_menuFragment);
        }
    }
}