package jp.co.asterisk.asreader.a23d.demoapp.fragments;

import android.os.Bundle;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.navigation.fragment.NavHostFragment;

import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import jp.co.asterisk.asreader.a23d.demoapp.MainActivity;
import jp.co.asterisk.asreader.a23d.demoapp.R;
import jp.co.asterisk.asreader.a23d.demoapp.databinding.FragmentInfoBinding;
import jp.co.asterisk.asreader.a23d.sdk.AsReader;
import jp.co.asterisk.asreader.a23d.sdk.devicemanager.DeviceManager;

public class InfoFragment extends BaseFragment {

    private FragmentInfoBinding binding;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
    }

    @Override
    public View onCreateView( @NonNull LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState ) {
        // Inflate the layout for this fragment
        binding = FragmentInfoBinding.inflate(inflater, container, false);
        return binding.getRoot();
    }

    @Override
    public void onViewCreated(@NonNull View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);

        setTitle(getString(R.string.information));
        setBackButtonVisibility(View.VISIBLE);
        setRightButtonVisibility(View.VISIBLE);
        setRightButtonEnabled(true);
        setRightButtonText(getString(R.string.refresh));
    }

    @Override
    public void onStart() {
        super.onStart();
        Log.d("InfoFragment", "onStart");
        enableActionBar(true);
    }

    @Override
    public void onResume() {
        super.onResume();

        requestReaderInformation();
    }

    private void requestReaderInformation() {
        binding.infoTextView.append(" APP: "+ ((MainActivity)requireActivity()).getAppVersion()
						+ " \n SDK: "+ AsReader.getInstance().getVersion());
        AsReader asreader = AsReader.getInstance();
        DeviceManager manager = asreader.getDeviceManager();
        manager.getReaderInfo();
    }

    @Override
    public void onRightButtonClick() {
        binding.infoTextView.setText("");
        requestReaderInformation();
    }

    @Override
    public void onConnect(boolean isConnect) {
        Log.d("InfoFragment", "onConnect");
        if (!isConnect) {
            NavHostFragment.findNavController(InfoFragment.this)
                    .navigate(R.id.action_InfoFragment_to_MenuFragment);
        }
    }

    public void setReaderInfo(String model, String hwVersion, String fwVersion) {
        binding.infoTextView.append("\n Model: " + model +
                "\n HW ver. " + hwVersion +
                "\n FW ver. " + fwVersion);
    }
}