package jp.co.asterisk.asreader.a23d.demoapp.util;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

import java.util.ArrayList;

import jp.co.asterisk.asreader.a23d.demoapp.R;


public class CustomTagAdapter extends BaseAdapter {
    private ArrayList<CellData> mItems = new ArrayList<>();
    private int tagCount = 0;

    @Override
    public int getCount() {
        return mItems.size();
    }

    @Override
    public CellData getItem(int position) {
        return mItems.get(position);
    }

    @Override
    public long getItemId(int position) {
        return 0;
    }

    public View getView(int position, View convertView, ViewGroup parent) {
        Context context = parent.getContext();

        if (convertView == null) {
            LayoutInflater inflater = (LayoutInflater) context.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
            convertView = inflater.inflate(R.layout.cell_tag, parent, false);
        }

        TextView tvTagName = (TextView) convertView.findViewById(R.id.tvTagName);
        TextView tvTagCount = (TextView) convertView.findViewById(R.id.tvTagCount);
        TextView tvTagRssi = (TextView) convertView.findViewById(R.id.tvTagRssi);

        CellData cell = getItem(position);

        tvTagName.setText(cell.getName());
        tvTagCount.setText(cell.getTagCount() + 1 + "");
        tvTagRssi.setText(cell.getRssi());

        return convertView;

    }

    public void clear() {
        mItems.clear();
        this.notifyDataSetChanged();
    }

    public void addItem(String tag, int count, float rssi) {
        CellData cell = new CellData();

        boolean newTag = true;

        for (int i = 0; i < mItems.size(); i++) {
            if (tag.equals(mItems.get(i).getName())) {

                tagCount = mItems.get(i).getTagCount() + 1;
                mItems.get(i).setName(tag);
                mItems.get(i).setTagCount(tagCount);
                mItems.get(i).setRssi(rssi == 0 ? "" : rssi + "");
                newTag = false;
                return;
            }
        }

        if (newTag) {
            if (count != 0)
                cell.setTagCount(count);

            cell.setName(tag);
            cell.setRssi(rssi == 0 ? "" : rssi + "");

            mItems.add(cell);
        }
    }


}

