package jp.co.asterisk.asreader.a23d.demoapp.util;

import android.content.Context;
import android.content.SharedPreferences;

import androidx.preference.PreferenceManager;

public class SharedPreferencesHelper {
    private static SharedPreferencesHelper instance;

    private final String PREF_KEY_READER_CONNECT_TYPE = "PREF_KEY_READER_CONNECT_TYPE";
    private final String PREF_KEY_HID_MODE = "PREF_KEY_HID_MODE";
    private final String PREF_KEY_POWER_STATE = "PREF_KEY_POWER_STATE";
    private final String PREF_KEY_BEEP = "PREF_KEY_BEEP";
    private final String PREF_KEY_VIBRATION = "PREF_KEY_VIBRATION";
    private final String PREF_KEY_LED = "PREF_KEY_LED";
    private final String PREF_KEY_AIMER = "PREF_KEY_AIMER";
    private final String PREF_KEY_POWER_ON_BEEP = "PREF_KEY_POWER_ON_BEEP";

    private SharedPreferences sharedPreferences;

    private SharedPreferencesHelper() {}

    public static SharedPreferencesHelper getInstance() {
        if (instance == null) instance = new SharedPreferencesHelper();
        return instance;
    }

    public void initialize(Context context) {
        sharedPreferences = PreferenceManager.getDefaultSharedPreferences(context);
    }

    public void setReaderConnectType(boolean type) {
        sharedPreferences.edit().putBoolean(PREF_KEY_READER_CONNECT_TYPE, type).apply();
    }

    public boolean getReaderConnectType() {
        return sharedPreferences.getBoolean(PREF_KEY_READER_CONNECT_TYPE, true);
    }

    public void setHidMode(boolean hidMode) {
        sharedPreferences.edit().putBoolean(PREF_KEY_HID_MODE, hidMode).apply();
    }

    public boolean getHidMode() {
        return sharedPreferences.getBoolean(PREF_KEY_HID_MODE, false);
    }

    public void setPowerState(boolean powerState) {
        sharedPreferences.edit().putBoolean(PREF_KEY_POWER_STATE, powerState).apply();
    }

    public boolean getPowerState() {
        return sharedPreferences.getBoolean(PREF_KEY_POWER_STATE, true);
    }

    public void setBeep(boolean beep) {
        sharedPreferences.edit().putBoolean(PREF_KEY_BEEP, beep).apply();
    }

    public boolean getBeep() {
        return sharedPreferences.getBoolean(PREF_KEY_BEEP, true);
    }

    public void setVibration(boolean vibration) {
        sharedPreferences.edit().putBoolean(PREF_KEY_VIBRATION, vibration).apply();
    }

    public boolean getVibration() {
        return sharedPreferences.getBoolean(PREF_KEY_VIBRATION, true);
    }

    public void setLed(boolean led) {
        sharedPreferences.edit().putBoolean(PREF_KEY_LED, led).apply();
    }

    public boolean getLed() {
        return sharedPreferences.getBoolean(PREF_KEY_LED, true);
    }

    public void setAimer(boolean aimer) {
        sharedPreferences.edit().putBoolean(PREF_KEY_AIMER, aimer).apply();
    }

    public boolean getAimer() {
        return sharedPreferences.getBoolean(PREF_KEY_AIMER, true);
    }

    public void setPowerOnBeep(boolean powerOnBeep) {
        sharedPreferences.edit().putBoolean(PREF_KEY_POWER_ON_BEEP, powerOnBeep).apply();
    }

    public boolean getPowerOnBeep() {
        return sharedPreferences.getBoolean(PREF_KEY_POWER_ON_BEEP, true);
    }
}
