package jp.co.asterisk.asreader.a23d.demoapp.util;

import android.content.Context;
import android.content.pm.PackageManager;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.BaseAdapter;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;

import java.util.ArrayList;

import jp.co.asterisk.asreader.a23d.demoapp.R;

public class TagDataListAdapter extends BaseAdapter {

    private Context context;
    private LayoutInflater inflater;
    private ArrayList<TagData> tagDataList;

    public TagDataListAdapter(Context context) {
        this.context = context;
        inflater = (LayoutInflater)context.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
    }

    public void setTagDataList(ArrayList<TagData> tagDataList) {
        this.tagDataList = tagDataList;
    }

    @Override
    public int getCount() {
        return tagDataList.size();
    }

    @Override
    public Object getItem(int position) {
        return tagDataList.get(position);
    }

    @Override
    public long getItemId(int position) {
        return 0;
    }

    @NonNull
    @Override
    public View getView(int position, @Nullable View convertView, @NonNull ViewGroup parent) {
        if (convertView == null) {
            convertView = inflater.inflate(R.layout.list_item_tag, parent, false);
        }

        TagData tagData = (TagData) getItem(position);

        TextView nameTextView = convertView.findViewById(R.id.name_text_view);
        TextView countTextView = convertView.findViewById(R.id.count_text_view);
        TextView rssiTextView = convertView.findViewById(R.id.rssi_text_view);

        nameTextView.setText(tagData.getName());
        countTextView.setText(String.valueOf(tagData.getCount() + 1));
        rssiTextView.setText(tagData.getRssi());

        return convertView;
    }
}
