package jp.co.asterisk.asreader.a23d.demoapp.util;


import android.app.Activity;
import android.app.AlertDialog;
import android.app.ProgressDialog;
import android.content.DialogInterface;
import android.content.pm.PackageManager;
import android.content.pm.PackageManager.NameNotFoundException;
import android.media.MediaPlayer;
import android.os.Handler;
import android.os.Looper;
import android.os.Message;
import android.util.Log;
import android.widget.Toast;

import androidx.annotation.NonNull;

import jp.co.asterisk.asreader.a23d.demoapp.R;


public class Utils {

    private static final Utils mInstance = new Utils();
    private Activity activity;

    public static Utils getInstance() {
        return mInstance;
    }

    public String getAppVersion(Activity act) {
        String versionName = "";
        String packageName = act.getPackageName();

        // Get Application Version
        try {
            versionName = act.getPackageManager().getPackageInfo(packageName, PackageManager.GET_META_DATA).versionName;
        } catch (NameNotFoundException e) {
            versionName = "";
        }

        return versionName;
    }


    public void showToast(final Activity activity, final String strMessag) {
        activity.runOnUiThread(new Runnable() {
            public void run() {
                Toast.makeText(activity.getApplicationContext(), strMessag, Toast.LENGTH_SHORT).show();
            }
        });

    }


    MediaPlayer mediaPlayer = null;

    public void playSound(final Activity act) {
        if (mediaPlayer == null)
            mediaPlayer = MediaPlayer.create(act.getApplicationContext(), R.raw.read);

        new Thread(new Runnable() {
            @Override
            public void run() {
                mediaPlayer.start();
                try {
                    Thread.sleep(10);
                } catch (InterruptedException e) {
                    // TODO Auto-generated catch block
                    e.printStackTrace();
                }
            }
        }).start();
    }

    AlertDialog.Builder builder;

    public void showAlert(final Activity activity, final String msg) {
        activity.runOnUiThread(new Runnable() {
            public void run() {
                builder = new AlertDialog.Builder(activity);
                builder.setTitle(" Alert  ");
                builder.setMessage(msg);
                builder.setCancelable(false);
                builder.setPositiveButton("OK", new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface arg0, int arg1) {
                        android.os.Process.killProcess(android.os.Process.myPid());
                    }
                });

                builder.show();
            }
        });
    }

    AlertDialog.Builder builder2;

    public void showExitAlert(final Activity activity) {
        activity.runOnUiThread(new Runnable() {
            public void run() {
                builder2 = new AlertDialog.Builder(activity, android.R.style.Theme_DeviceDefault_Light_Dialog);
                builder2.setTitle(" Alert  ");
                builder2.setMessage("Do you want to exit the program?");
                builder2.setPositiveButton("Exit", new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface arg0, int arg1) {
                        android.os.Process.killProcess(android.os.Process.myPid());
                    }
                });

                builder2.setNegativeButton("Cancel", new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {

                    }
                });

                builder2.show();
            }
        });
    }

    AlertDialog.Builder builder3;

    public void showReconnectAlert(final Activity activity, final String msg) {
        activity.runOnUiThread(new Runnable() {
            public void run() {
                builder3 = new AlertDialog.Builder(activity);
                builder3.setTitle(" Alert  ");
                builder3.setMessage(msg);
                builder3.setCancelable(false);

                builder3.show();
            }
        });
    }

    // TODO: 修正する必要あり
    ProgressDialog oDialog;

    public void showProgressbar(final Activity activity, final boolean isShow) {
        activity.runOnUiThread(() -> {
            if (isShow) {
                oDialog = new ProgressDialog(activity, android.R.style.Theme_DeviceDefault_Light_Dialog);
                oDialog.setProgressStyle(ProgressDialog.STYLE_SPINNER);
                oDialog.setCanceledOnTouchOutside(false);
                oDialog.setMessage("Checking HID Mode..");
                oDialog.show();
            } else {
                if (oDialog != null) {
                    oDialog.dismiss();
                    oDialog = null;
                }
            }
        });
    }

    ProgressDialog oDialog2 = null;

    public void showSettingProgressbar(final Activity activity, final boolean isShow) {
        activity.runOnUiThread(new Runnable() {
            public void run() {
                if (isShow) {
                    oDialog2 = new ProgressDialog(activity, android.R.style.Theme_DeviceDefault_Light_Dialog);
                    oDialog2.setProgressStyle(ProgressDialog.STYLE_SPINNER);
                    oDialog2.setCanceledOnTouchOutside(false);
                    oDialog2.setMessage("Please wait..");
                    oDialog2.show();
                } else {
                    if (oDialog2 != null) {
                        oDialog2.dismiss();
                        oDialog2 = null;
                    }
                }
            }
        });
    }
}
